function [par, stdPar] = estDegMLA(y,x0,n,a1,P1)

options = optimset('LargeScale','off','Display','iter','TolFun',1e-10,'TolX',1e-4,'Algorithm','interior-point','UseParallel','never');

AA = [];
b = [];
Aeq = [];
beq = [];

fTarget = @(x) arrangeTarget(y,x,n,a1,P1);

n2 = n.^2;
nPar = length(x0);

% elements of Psi 
lb(1) = 0;
lb(4) = 0;

lb(2) = -0.4;
lb(3) = -0.4;

ub(1) = 0.99;
ub(4) = 0.99;

ub(2) = 0.4;
ub(3) = 0.4;

% elements of q and S

lb(n2+1:nPar)=0;
ub(n2+1:nPar)=1;


[par,logL,~,~,~,~,hessian] = fmincon(fTarget,x0,AA,b,Aeq,beq,lb,ub,[],options);

stdPar = sqrt(diag(inv(hessian)));

