function [invA, logDetA] = invA(A)

thresholdSDV = 1e-3;

% TSDV inversion
[U, S, V]= svd(A);
s = diag(S);
index = s > thresholdSDV;
k = sum(index);
logDetA = sum(log(s(index)));

invA = (U(:, 1: k)* diag(1./ s(1: k))* V(:, 1: k)')';
