clear all;
close all;
clc;

load('\results\LSim.mat');
load('\results\QSim.mat');
load('\results\LEst.mat');
load('\results\QEst.mat');
load('\results\assetSet.mat');

%% 

d = size(LSim,1);
nSim = size(LEst,1);

statA = nan(nSim,d,d);
statQ = nan(nSim,d,d);

%%

for k = 1:nSim
    for i = 1:d
        for j = 1:d
            statA(k,i,j) = (LEst(k,i,j) - LSim(i,j))/nanstd(squeeze(LEst(:,i,j)));
        end
    end
end

for k = 1:nSim
    for i = 1:d
        for j = 1:i
            statQ(k,i,j) = (QEst(k,i,j) - QSim(i,j))/nanstd(squeeze(QEst(:,i,j)));
        end
    end
end

%% Figures

edges = [-5:0.2:5];
f = exp(-edges.^2./2)./sqrt(2*pi);

figure;
subplot(2,2,1);
histogram(squeeze(statA(:,1,1)),edges,'Normalization','pdf');
hold on
plot(edges,f,'LineWidth',1.5);
title('F_{11}');
set(gca,'XTick',-5:2.5:5);
subplot(2,2,2);
histogram(squeeze(statA(:,1,2)),edges,'Normalization','pdf');
hold on
plot(edges,f,'LineWidth',1.5);
title('F_{12}');
set(gca,'XTick',-5:2.5:5);
subplot(2,2,3);
histogram(squeeze(statA(:,2,1)),edges,'Normalization','pdf');
hold on
plot(edges,f,'LineWidth',1.5);
title('F_{21}');
set(gca,'XTick',-5:2.5:5);
subplot(2,2,4);
histogram(squeeze(statA(:,2,2)),edges,'Normalization','pdf');
hold on
plot(edges,f,'LineWidth',1.5);
title('F_{22}');

figure;
subplot(1,3,1);
histogram(squeeze(statQ(:,1,1)),edges,'Normalization','pdf');
hold on
plot(edges,f,'LineWidth',1.5);
title('\Sigma_{11}');
set(gca,'XTick',-5:2.5:5);
subplot(1,3,2);
histogram(squeeze(statQ(:,2,1)),edges,'Normalization','pdf');
hold on
plot(edges,f,'LineWidth',1.5);
title('\Sigma_{12}');
set(gca,'XTick',-5:2.5:5);
% subplot(2,2,3);
% histogram(squeeze(statQ(:,2,1)),edges,'Normalization','pdf');
% hold on
% plot(edges,f,'LineWidth',1.5);
% title('Q_{21}');
subplot(1,3,3);
histogram(squeeze(statQ(:,2,2)),edges,'Normalization','pdf');
hold on
plot(edges,f,'LineWidth',1.5);
title('\Sigma_{22}');
set(gca,'XTick',-5:2.5:5);

figure;
edges11 = [-5:0.2:15];
f11 = exp(-edges11.^2./2)./sqrt(2*pi);
histogram(squeeze(statQ(:,1,1)),edges11,'Normalization','pdf');
hold on;
plot(edges11,f11,'LineWidth',3);
title('\Sigma_{11}');
set(gca, 'FontSize', 14);
set(gca,'XTick',-5:2.5:15);

figure;
edges21 = [-5:0.2:20];
f21 = exp(-edges21.^2./2)./sqrt(2*pi);
histogram(squeeze(statQ(:,2,1)),edges21,'Normalization','pdf');
hold on;
plot(edges21,f21,'LineWidth',3);
title('\Sigma_{12}');
set(gca, 'FontSize', 14);
set(gca,'XTick',-5:2.5:20);

figure;
edges22 = [-5:0.2:10];
f22 = exp(-edges22.^2./2)./sqrt(2*pi);
histogram(squeeze(statQ(:,2,2)),edges22,'Normalization','pdf');
hold on;
plot(edges22,f22,'LineWidth',3);
title('\Sigma_{22}');
set(gca, 'FontSize', 14);
set(gca,'XTick',-5:2.5:10);

         
    