function S=HayashiYoshida(P,n1,n2)

% 
% This function computes a realized covariance estimation taking 
% all the cross product among returns having a non-zero overlap. 

% preliminaries and memory alloc
d=size(P,2);
S=zeros(d);

for i=1:d
    for j=i:d
        if i==j
            S(i,i) = TSRV(P(isnan(P(:,i))==0,i),n1,n2);
            S(i,i) = abs(S(i,i));
        else
            time=(1:rows(P))';
            tickPriceA=[time(isnan(P(:,i))==0), P(isnan(P(:,i))==0,i)];
            tickPriceB=[time(isnan(P(:,j))==0), P(isnan(P(:,j))==0,j)];

            if tickPriceB(2,1)>=tickPriceA(2,1), tickPrice1=tickPriceB; tickPrice2=tickPriceA;
            else tickPrice1=tickPriceA; tickPrice2=tickPriceB; end
            N1=rows(tickPrice1); N2=rows(tickPrice2);

            % covariance estimation 
            t1=2; t2=2; crossprod=0;
            while t1 <= N1,
                returnsum2=0;
                while tickPrice2(t2,1) < tickPrice1(t1,1) && t2<N2,
                    returnsum2= returnsum2 + tickPrice2(t2,2)-tickPrice2(t2-1,2);
                    t2=t2+1;
                end
                returnsum2= returnsum2 + tickPrice2(t2,2)-tickPrice2(t2-1,2);
                crossprod= crossprod + returnsum2*(tickPrice1(t1,2)-tickPrice1(t1-1,2));
                if tickPrice2(t2,1) == tickPrice1(t1,1) && t2+1<=N2, t2=t2+1; end
                t1=t1+1;
            end
            S(i,j) = sum(crossprod);
            S(j,i) = S(i,j);
        end
    end
end