function [sigma2TS, eta2TS] = TSRV(x,n1,n2)

%%% TWO SCALE ESTIMATOR (from Fulvio's GJKfunct.m)
% x: vector of log-prices
% n_1: the high-frequency
% n_2: the low frequency
% NOTE: if n1 is different from 1, I subsample also the higher frequency
% OUPUT
% sigma2TS: daily integrated variance
% eta2TS: daily variance of the microstructure noise

N=rows(x);

r1 = x(1+n1:N,:) - x(1:N-n1,:);
r2 =x(1+n2:N,:) - x(1:N-n2,:);

RV1 = sum(r1.^2);
RV2 = sum(r2.^2);

sigma2TS  = (1-n1/n2)^-1*(RV2/n2 - RV1/n2);

% To estimate the variance of the noise
r_all = x(1+1:N,:) - x(1:N-1,:);
RVall = sum(r_all.^2);

eta2TS = RVall/2;

%eta2TS = (RVall - sigma2TS)/2;

% eta2TS = (1-n2/n1)^(-1)*n2/2*(RV2/n2 - RV1/n1);  % Alternative estimation of the variance of the noise (worse when n1>>1)

