
% Add SPY data to existing dataset. Replaces the SP500 future

str1 = sprintf('%s/P.mat',groupType);
str2 = sprintf('%s/assetSet%s.mat',groupType,groupType);
str3 = sprintf('%s/timeMaster.mat',groupType);

load(str1);
load(str2);
load(str3);

T = size(P,3);

load('data/dataSPY.mat');
load('data/timeMasterSPY.mat');

d = numel(assetSet)+1;
assetSet{d} = 'SPY';

k=0;

[days,ia,ib] = intersect(timeMasterSPY,timeMaster);

nDays = length(days);
PP = nan(nDays,d,T);
nObs = nan(d,nDays);

for i = 1:nDays
    
    clc;
    fprintf('Pre-processing...\n');
    fprintf('Day %s of %s...\n',num2str(i),num2str(nDays));
    
    index = find(timeMaster == days(i));
    
    PP(i,1:d-1,:) = P(index,1:d-1,:);
    str = ['PP(i,d,:) = data.day',num2str(ia(i)),'.price;'];
    eval(str);
    
    nObs = sum(~isnan(squeeze(PP(i,:,:))),2)/T;  % n. of observations
    
end

timeMaster = days;

str1 = sprintf('%s2ndRound/assetSet.mat',groupType);
str2 = sprintf('%s2ndRound/PP.mat',groupType);
str3 = sprintf('%s2ndRound/timeMaster.mat',groupType);
str4 = sprintf('%s2ndRound/nObs.mat',groupType);

save(str1,'assetSet');
save(str2,'PP','-v7.3');
save(str3,'timeMaster');
save(str4,'nObs');
