
nIter = 2000;         % maximum n. of iterations
tol = 1e-4;          % min likelihood changing tolerance

showPlot = true;

% EM initialization

trueQ = [QSim,zeros(d);zeros(d,2*d)];
trueR = RSim;
trueF = [eye(d)+LSim,-LSim;eye(d),zeros(d)];
C = [eye(d),zeros(d)];

rnd1 = rand;
rnd2 = rand;

shift1 = 0.2*((rnd1>0.5) - (rnd1<0.5));
shift2 = 0.2*((rnd2>0.5) - (rnd2<0.5));

Q0 = [QSim*(1+shift1),zeros(d);zeros(d,2*d)];
R0 = RSim*(1+shift1);

[~,D] = eig(LSim*(1+shift2));
if any(abs(diag(D)) >= 1)
    disp('Initial transition matrix is not stationary!');
end

F0 = [eye(d)+LSim*(1+shift2),-LSim*(1+shift2);eye(d),zeros(d)];

